book/urls.py
from django.urls import path

from . import views

app_name = 'book'

urlpatterns = [
    path('book/', views.index, name='index'),
    path('data/', views.fungsi_data, name='fungsi_data')

    
]

story4/urls.py
from django.contrib import admin
from django.urls import include, path

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('main.urls')),
    path('matkul/', include('matkul.urls')),
    path('tasks/', include('tasks.urls')),
    path('accordion/', include('accordion.urls')),
    path('', include('book.urls')),
    path('', include('account.urls')),


]

tasks/urls.py
from django.urls import path

from . import views

app_name = 'tasks'

urlpatterns = [
    path('', views.index, name='index'),
    path("<int:task_id>/", views.task, name="task"),
    path("create/", views.create_task, name="create_task"),
    path("<int:task_id>/delete/", views.delete_task, name="delete_task"),
    path("create_anggota/", views.create_anggota, name="create_anggota")
]

tasks/models.py
from django.db import models

# Create your models here.
class Tasks(models.Model):
    name = models.CharField(max_length=64)
    def __str__(self):
        return self.name

class Anggota(models.Model):
    name = models.CharField(max_length=64)
    task = models.ForeignKey(Tasks, related_name='task', on_delete=models.CASCADE, default=1)
    def __str__(self):
        return self.name
 

tasks/forms.py
from django.db import models
from django import forms
from .models import Tasks, Anggota

class formTasks(forms.ModelForm):
    class Meta:
        model = Tasks
        fields = ['name']

class formAnggota(forms.ModelForm):
    class Meta:
        model = Anggota
        fields = ['name', 'task']

tasks/views.py
from django.shortcuts import get_object_or_404, render, redirect
from.models import Tasks, Anggota
from .forms import formTasks, formAnggota
from django.http import HttpResponseRedirect
# Create your views here.

def index(request):
    return render(request, "tasks/index.html",{
        "task": Tasks.objects.all()
    })

def task(request, task_id):
    form = formAnggota(request.POST or None)
    if form.is_valid():
        form.save()
    task = Tasks.objects.get(pk=task_id)
    anggota = Anggota.objects.filter(task__id=task_id)
    return render(request, "tasks/task.html", {
        "task": task, "form":form, "anggota": anggota
    })

def create_anggota(request):
    form = formAnggota(request.POST or None)
    if form.is_valid():
        form.save()
        return redirect('../')
    context = {'form': form}
    return render(request, "tasks/create_anggota.html", context)

def create_task(request):
    form = formTasks(request.POST or None)
    if form.is_valid():
        form.save()
        return redirect('../')
    context = {'form': form}
    return render(request, "tasks/create_task.html", context)

def delete_task(request, task_id):
    obj=get_object_or_404(Tasks, pk=task_id)
    if request.method == "POST":
        obj.delete()
        return redirect('../../')
    context = {"object" : obj}
    return render(request, "tasks/delete_task.html", context)

tasks/templates/tasks/create_anggota.html
{% extends 'base.html' %}
{% load static %}
{% block meta %}
<title>Create Tasks</title>
{% endblock meta %}
{% block content %}
<div class="header-container">
    <br><br>
    <p id="welcome">Add Anggota</p>
    <br><br><br>
    <div class="container">
        <div class="row">
            <div class="row col-md-12">
                <form method="POST"> {% csrf_token %}
                    {{ form.as_p }}
                    <br>
                    <input class="btn btn-success btn-lg active" role="button" type="submit" value="Save">
                </form>
                <div class="button">
                    <br><br><br>
                    <a class="btn btn-primary" href="{% url 'tasks:index' %}"  role="button">Back to the list</a>
                    <br><br><br>
                </div>
            </div> 
        </div>
    </div>
    

{% endblock content %}

tasks/templates/tasks/create_task.html
{% extends 'base.html' %}
{% load static %}
{% block meta %}
<title>Create Tasks</title>
{% endblock meta %}
{% block content %}
<div class="header-container">
    <br><br>
    <p id="welcome">Add Tasks</p>
    <br><br><br>
</div>
<div class="container">
    <div class="row">
        <div class="row col-md-12">
            <form method="POST"> {% csrf_token %}
                {{ form.as_p }}
                <br>
                <input class="btn btn-success btn-lg active" role="button" type="submit" value="Save">
            </form>
            <div class="button">
                <br><br><br>
                <a class="btn btn-primary" href="{% url 'tasks:index' %}"  role="button">Back to the list</a>
                <br><br><br>
            </div>
        </div> 
    </div>
</div>

{% endblock content %}

tasks/templates/tasks/delete_task.html
{% extends 'base.html' %}
{% load static %}
{% block meta %}
<title>Delete Tasks?</title>
{% endblock meta %}
{% block content %}
<form action='.' method='POST'> 
    {% csrf_token %}
    <div class="header-container">
        <br><br><br><br><br><br><br><br><br>
        <p id="welcome">You want to delete {{ object.name}}? Are you sure?</p>
        <br><br><br>
    </div>
    <div class="text-center">
        <p>
            <input class="btn btn-primary btn-lg active" role="button" type="submit" value="Yes, Please :)">
            <a href="../../" class="btn btn-secondary btn-lg active" role="button" aria-pressed="true">Nahhhhh :'(</a>
        </p>
    </div>
</form>
<br><br><br><br><br><br>
{% endblock content %}

tasks/templates/tasks/index.html
{% extends 'base.html' %}
{% load static %}
{% block meta %}
<title>Tasks</title>
{% endblock meta %}
{% block content %}
<div class="header-container">
    <br><br>
    <p id="welcome">Welcome!</p>
    <p id="photo-gallery">daftarkan dirimu di sini!</p>
    <br>
</div>
<div class="add">
    <div class="text-center">
        <div class="button">
            <a class="btn btn-primary" href="{% url 'tasks:create_task' %}" role="button">Add Tasks</a>
            <a class="btn btn-primary" href="{% url 'tasks:create_anggota' %}" role="button">Add Anggota</a>
            <br><br><br>
        </div>
    </div>
</div>
<div class="listnya">
    <div class="container">
        <div class="row">
            <div class="row col-md-12">
                {%for items in task %}
                    <div class="list-group">
                        <a href="{% url 'tasks:task' items.id %}" class="list-group-item list-group-item-action">{{ items.name }}</a>
                    </div>
                    <a class="btn btn-danger" href="{% url 'tasks:delete_task' items.id %}" role="button">Delete</a>
                    <br><br><br>
                {% endfor %}
                
            </div>
        </div> 
    </div>
</div>
<br><br><br><br><br><br><br><br>
{% endblock content %}

tasks/templates/tasks/task.html
{% extends 'base.html' %}
{% load static %}
{% block meta %}
<title>Detail Tasks</title>
{% endblock meta %}
{% block content %}
<div class="header-container">
    <br><br>
    <p id="welcome">{{ task.title }}</p>
    <br><br>
</div>
<div class="tulisan">
    <div class="container">
        <div class="row">
            <div class="row col-md-12">
                {% for items in anggota %}
                    <ul>
                        <li>{{ items.name }}</li>
                    </ul>
                {% endfor %}
                <br><br>
                <div class="button">
                    <a class="btn btn-primary" href="{% url 'tasks:index' %}" role="button">Back to the list</a>                    
                </div>
            </div>
        </div>
    </div>
    <br><br><br><br><br><br><br><br><br><br><br><br><br><br>
</div>
{% endblock content %}